%define version 0.5.9
%define rel 1
%define CHROOTDIR /var/spool/vscan
%define BASE_LIBS glibc,libgcc,expat,libstdc++,zlib,bzip2-libs
%define ARCHIVERS tar,arc,unace,unrar,rar,zoo,unarj,arj,unzip,zip,gzip,bzip2
%define ANTIVIRS clamav,clamav-libs,avglinux,nod32lfs,kav4mailservers-linux
%define ANTISPAMS bogofilter,qsf

Summary:   sagator - antivir gateway for smtp server
Name:      sagator
Version:   %{version}
Release:   %rel%{?repo}
#Epoch:     1
Source:    http://www.salstar.sk/pub/antivir/snapshots/sagator-%{version}.tar.bz2
URL:       http://www.salstar.sk/pub/antivir/sagator/
Copyright: GPL
Packager:  Jan ONDREJ (SAL) <ondrejj(at)salstar.sk>
Group:     System Environment/Daemons
Requires:  python >= 2.2.2, initscripts, postfix
#BuildArch: noarch
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildRequires:	python >= 2.2.2, initscripts

%description
This package is an interface between smtp server and antivir/spamchecker.

%package libclamav
Summary:   ClamAV native support via libclamav
Group:     Libraries
#BuildArch: i386
Requires:  %{name}

%description libclamav
This is a ClamAV native support via libclamav.

%if %{!?_with_dspam:0}%{?_with_dspam:1}
%package pydspam
Summary: DSPAM python module for sagator
Group: Libraries
#BuildArch: i386
Requires:  %{name}

%description pydspam
pydspam.so is an library (module) for python to use DSPAM antispam.
It is designed for sagator.
%endif

%prep
%setup -n %{name}

%build
./configure --prefix=/usr
make

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

make DESTDIR=$RPM_BUILD_ROOT PREFIX=/usr install
rm -f $RPM_BUILD_ROOT/usr/lib/sagator/config.py[co]
mkdir -p $RPM_BUILD_ROOT/var/spool/vscan/tmp/quarantine

%pre
id vscan > /dev/null 2>&1 || adduser -r -M vscan

%post
#exec &>/dev/null
# Adding postfix config
if [ $1 = 2 ]; then # upgrade
  [ -f /etc/sysconfig/sagator ] && . /etc/sysconfig/sagator || true
  # update configuration
  /usr/lib/sagator/updatecfg.py || true
  if [ "$RESTART" = "auto" ]; then
    # restart sagator
    /etc/init.d/sagator restart || true
  fi
else # install
  if [ -x /sbin/chkconfig ]; then
    chkconfig --add sagator
  fi
  mkdir -p %{CHROOTDIR}
  /usr/sbin/mkchroot.sagator --auto
  if grep -q "^#begin: sagator" /etc/postfix/main.cf >/dev/null; then
    echo "Postfix main configuration already done."
  else
    echo -e \
      "#begin: sagator\ncontent_filter=smtp:[127.0.0.1]:27\n#end: sagator\n" \
      >> /etc/postfix/main.cf << EOF
  fi
  if grep -q "^#begin: sagator" /etc/postfix/master.cf >/dev/null; then
    echo "Postfix master configuration already done."
  else
    cat >> /etc/postfix/master.cf << EOF
#begin: sagator
127.0.0.1:26	inet n - n - 30 smtpd
  -o content_filter=
  -o myhostname=sagator.`hostname`
  -o local_recipient_maps=  -o relay_recipient_maps=
  -o mynetworks=127.0.0.0/8  -o mynetworks_style=host
  -o smtpd_restriction_classes=  -o smtpd_client_restrictions=
  -o smtpd_helo_restrictions=  -o smtpd_sender_restrictions=
  -o smtpd_recipient_restrictions=permit_mynetworks,reject
  -o receive_override_options=no_unknown_recipient_checks,no_header_body_checks
#end: sagator
EOF
  fi
  # reload postfix
  /etc/init.d/postfix reload || true
  # start sagator
  /etc/init.d/sagator start || true
fi

%preun
#exec &>/dev/null
if [ $1 = 0 ]; then # uninstall
  [ "%{CHROOTDIR}" != "/" ] && rm -rf %{CHROOTDIR}/*
  if [ "$1" = 0 ] ; then
    if [ -x /sbin/chkconfig ]; then
      chkconfig --del sagator
    fi
  fi
  # Removing postfix config
  mv /etc/postfix/main.cf /etc/postfix/main.cf.tmp
  sed '/^#begin: sagator/,/^#end: sagator/d' \
    < /etc/postfix/main.cf.tmp > /etc/postfix/main.cf
  mv /etc/postfix/master.cf /etc/postfix/master.cf.tmp
  sed '/^#begin: sagator/,/^#end: sagator/d' \
    < /etc/postfix/master.cf.tmp > /etc/postfix/master.cf
  /etc/init.d/postfix reload || true
  # Remove mrtg.config
  cp -f /etc/crontab /etc/crontab.tmp && \
    sed '/^#begin: sagator/,/^#end: sagator/d' \
    < /etc/crontab.tmp > /etc/crontab
  rm -f /etc/crontab.tmp
fi

%triggerin -- mrtg
# add sagator's mrtg configuration
[ ! -d '/var/www/mrtg/sagator' ] && mkdir '/var/www/mrtg/sagator'
if [ ! -f /var/www/mrtg/sagator/index.html ]; then
  cat /usr/share/doc/sagator-%{version}/mrtg-index.html \
    | sed 's/statistics</statistics for '`hostname`'</g' \
    > /var/www/mrtg/sagator/index.html
  echo 'You will be able to see your stats at http://'`hostname`'/mrtg/sagator/'
fi
if grep -q "^#begin: sagator" /etc/crontab >/dev/null; then
  echo "Crontab configuration already done."
else
cat << EOF >> /etc/crontab
#begin: sagator
0-59/5 * * * * root /usr/bin/mrtg /etc/mrtg/sagator.cfg
#end: sagator
EOF
fi

%triggerun -- mrtg
# Remove mrtg.config
cp -f /etc/crontab /etc/crontab.tmp && \
  sed '/^#begin: sagator/,/^#end: sagator/d' \
  < /etc/crontab.tmp > /etc/crontab
rm -f /etc/crontab.tmp

%triggerin -- %{BASE_LIBS},%{ARCHIVERS},%{ANTIVIRS},%{ANTISPAMS}
/usr/sbin/mkchroot.sagator --auto || true

#%triggerpostun -- %{BASE_LIBS},%{ARCHIVERS},%{ANTIVIRS},%{ANTISPAMS}
#/usr/sbin/mkchroot.sagator --auto || true

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/sagator.conf
%config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/sysconfig/sagator
%config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/logrotate.d/sagator
%config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/mrtg/sagator.cfg
%dir /var/www/mrtg/sagator
%config(noreplace) %verify(not md5 size mtime) /var/www/mrtg/sagator/index.html
%{_sysconfdir}/rc.d/init.d/*
%config(noreplace) %verify(not md5 size mtime) %attr(755,root,root) %{_sysconfdir}/cron.daily/sagator
%config %verify(not md5 size mtime) %{_sysconfdir}/log.d/conf/services/sagator.conf
%config %verify(not md5 size mtime) %{_sysconfdir}/log.d/conf/logfiles/sagator.conf
%{_sysconfdir}/log.d/scripts/services/sagator
%doc doc/[A-Z]* TODO COPYING ChangeLog
%doc scripts/mrtg* scripts/rrd* *-template
%doc test
/usr/bin/*
/usr/sbin/*
%dir /usr/lib/sagator
/usr/lib/sagator/*.py*
%dir /usr/lib/sagator/av
/usr/lib/sagator/av/*.py*
%dir /usr/lib/sagator/as
/usr/lib/sagator/as/*.py*
%dir /usr/lib/sagator/interscan
/usr/lib/sagator/interscan/*.py*
%dir /usr/lib/sagator/srv
/usr/lib/sagator/srv/*.py*
/usr/share/man/man*/*
%dir /var/spool/vscan
%attr(1777,vscan,vscan) %dir /var/spool/vscan/tmp
%attr(0770,vscan,vscan) %dir /var/spool/vscan/tmp/quarantine
%if %(test -d /etc/yum.repos.d && echo 1 || echo 0)
%config(noreplace) %verify(not md5 size mtime) /etc/yum.repos.d/sagator.repo
%endif

%files libclamav
%defattr(-,root,root)
/usr/lib/sagator/libclamav.so

%if %{!?_with_dspam:0}%{?_with_dspam:1}
%files pydspam
%defattr(-,root,root)
/usr/lib/sagator/pydspam.so
%endif

%changelog
* Mon Dec 20 2004 Jan ONDREJ (SAL) <ondrejj(at)salstar.sk>
- Documentation moved into doc directory.
- man pages added
- dspam module

* Sun Nov  7 2004 Jan ONDREJ (SAL) <ondrejj(at)salstar.sk>
- chkconfig is started only on install (not upgrade)
- sagator is restarted only when RESTART=auto is configured in sysconfig
- You will be able ... message will show only on install
- Fedora Core 3 yum.repos.d autodetect

* Thu Aug 26 2004 Jan ONDREJ (SAL) <ondrejj(at)salstar.sk>
- logrotate script added

* Thu Aug  6 2004 Jan ONDREJ (SAL) <ondrejj(at)salstar.sk>
- srv/* added
- updatecfg.py in postinstall script

* Tue Jul  6 2004 Jan ONDREJ (SAL) <ondrejj(at)salstar.sk>
- mrtg script added

* Mon May 31 2004 Jan ONDREJ (SAL) <ondrejj(at)salstar.sk>
- cron script is now as configuration script (not replaced)

* Thu Apr 29 2004 Jan ONDREJ (SAL) <ondrejj(at)salstar.sk>
- added triggers

* Tue Apr 13 2004 Jan ONDREJ (SAL) <ondrejj(at)salstar.sk>
- /var/spool/vscam/tmp permission fix

* Wed Feb  4 2004 Jan ONDREJ (SAL) <ondrejj(at)salstar.sk>
- postfix requirement added
- fixed scriptlet fail when postfix is not started
- testing programs added to documentation

* Wed Jan 28 2004 Jan ONDREJ (SAL) <ondrejj(at)salstar.sk>
- configs are not replaced

* Mon Jan 19 2004 Jan ONDREJ (SAL) <ondrejj(at)salstar.sk>
- added sysconfig file
- added logrotate files
- config moved into /etc and symlink into /usr/lib/sagator

* Fri Oct 31 2003 Jan ONDREJ (SAL) <ondrejj(at)salstar.sk>
- added mrtg.cfg and index.html
- making of chroot removed on upgrading

* Thu Sep 18 2003 Jan ONDREJ (SAL) <ondrejj(at)salstar.sk>
- postfix is not reloaded, when sagator is upgrading

* Tue Jun 10 2003 Jan ONDREJ (SAL) <ondrejj(at)salstar.sk>
- first release
